# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.Contacts do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :Anniversary,
    :Birthdate,
    :ContactKeyNumeric,
    :OwnerMemberKeyNumeric,
    :AssistantEmail,
    :AssistantName,
    :AssistantPhone,
    :AssistantPhoneExt,
    :BusinessFax,
    :Children,
    :Company,
    :ContactKey,
    :ContactLoginId,
    :ContactPassword,
    :Department,
    :DirectPhone,
    :Email,
    :Email2,
    :Email3,
    :FirstName,
    :FullName,
    :HomeAddress1,
    :HomeAddress2,
    :HomeCarrierRoute,
    :HomeCity,
    :HomeFax,
    :HomePhone,
    :HomePostalCode,
    :HomePostalCodePlus4,
    :JobTitle,
    :LastName,
    :LeadSource,
    :MiddleName,
    :MobilePhone,
    :NamePrefix,
    :NameSuffix,
    :Nickname,
    :Notes,
    :OfficePhone,
    :OfficePhoneExt,
    :OriginatingSystemContactKey,
    :OriginatingSystemID,
    :OriginatingSystemName,
    :OtherAddress1,
    :OtherAddress2,
    :OtherCarrierRoute,
    :OtherCity,
    :OtherPostalCode,
    :OtherPostalCodePlus4,
    :OwnerMemberID,
    :OwnerMemberKey,
    :Pager,
    :PhoneTTYTDD,
    :ReferredBy,
    :SourceSystemContactKey,
    :SourceSystemID,
    :SourceSystemName,
    :SpousePartnerName,
    :TollFreePhone,
    :VoiceMail,
    :VoiceMailExt,
    :WorkAddress1,
    :WorkAddress2,
    :WorkCarrierRoute,
    :WorkCity,
    :WorkPostalCode,
    :WorkPostalCodePlus4,
    :ContactType,
    :Language,
    :ContactStatus,
    :HomeCountry,
    :HomeCountyOrParish,
    :HomeStateOrProvince,
    :OtherCountry,
    :OtherCountyOrParish,
    :OtherStateOrProvince,
    :OtherPhoneType,
    :PreferredAddress,
    :PreferredPhone,
    :WorkCountry,
    :WorkCountyOrParish,
    :WorkStateOrProvince,
    :ModificationTimestamp,
    :OriginalEntryTimestamp,
    :OwnerMember,
    :OriginatingSystem,
    :SourceSystem,
    :ContactListingNotes,
    :ContactListings,
    :Prospectings
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :Anniversary => Date.t | nil,
    :Birthdate => Date.t | nil,
    :ContactKeyNumeric => float() | nil,
    :OwnerMemberKeyNumeric => float() | nil,
    :AssistantEmail => String.t | nil,
    :AssistantName => String.t | nil,
    :AssistantPhone => String.t | nil,
    :AssistantPhoneExt => String.t | nil,
    :BusinessFax => String.t | nil,
    :Children => String.t | nil,
    :Company => String.t | nil,
    :ContactKey => String.t | nil,
    :ContactLoginId => String.t | nil,
    :ContactPassword => String.t | nil,
    :Department => String.t | nil,
    :DirectPhone => String.t | nil,
    :Email => String.t | nil,
    :Email2 => String.t | nil,
    :Email3 => String.t | nil,
    :FirstName => String.t | nil,
    :FullName => String.t | nil,
    :HomeAddress1 => String.t | nil,
    :HomeAddress2 => String.t | nil,
    :HomeCarrierRoute => String.t | nil,
    :HomeCity => String.t | nil,
    :HomeFax => String.t | nil,
    :HomePhone => String.t | nil,
    :HomePostalCode => String.t | nil,
    :HomePostalCodePlus4 => String.t | nil,
    :JobTitle => String.t | nil,
    :LastName => String.t | nil,
    :LeadSource => String.t | nil,
    :MiddleName => String.t | nil,
    :MobilePhone => String.t | nil,
    :NamePrefix => String.t | nil,
    :NameSuffix => String.t | nil,
    :Nickname => String.t | nil,
    :Notes => String.t | nil,
    :OfficePhone => String.t | nil,
    :OfficePhoneExt => String.t | nil,
    :OriginatingSystemContactKey => String.t | nil,
    :OriginatingSystemID => float() | nil,
    :OriginatingSystemName => String.t | nil,
    :OtherAddress1 => String.t | nil,
    :OtherAddress2 => String.t | nil,
    :OtherCarrierRoute => String.t | nil,
    :OtherCity => String.t | nil,
    :OtherPostalCode => String.t | nil,
    :OtherPostalCodePlus4 => String.t | nil,
    :OwnerMemberID => String.t | nil,
    :OwnerMemberKey => String.t | nil,
    :Pager => String.t | nil,
    :PhoneTTYTDD => String.t | nil,
    :ReferredBy => String.t | nil,
    :SourceSystemContactKey => String.t | nil,
    :SourceSystemID => float() | nil,
    :SourceSystemName => String.t | nil,
    :SpousePartnerName => String.t | nil,
    :TollFreePhone => String.t | nil,
    :VoiceMail => String.t | nil,
    :VoiceMailExt => String.t | nil,
    :WorkAddress1 => String.t | nil,
    :WorkAddress2 => String.t | nil,
    :WorkCarrierRoute => String.t | nil,
    :WorkCity => String.t | nil,
    :WorkPostalCode => String.t | nil,
    :WorkPostalCodePlus4 => String.t | nil,
    :ContactType => [String.t] | nil,
    :Language => [String.t] | nil,
    :ContactStatus => String.t | nil,
    :HomeCountry => String.t | nil,
    :HomeCountyOrParish => String.t | nil,
    :HomeStateOrProvince => String.t | nil,
    :OtherCountry => String.t | nil,
    :OtherCountyOrParish => String.t | nil,
    :OtherStateOrProvince => String.t | nil,
    :OtherPhoneType => String.t | nil,
    :PreferredAddress => String.t | nil,
    :PreferredPhone => String.t | nil,
    :WorkCountry => String.t | nil,
    :WorkCountyOrParish => String.t | nil,
    :WorkStateOrProvince => String.t | nil,
    :ModificationTimestamp => Date.t | nil,
    :OriginalEntryTimestamp => Date.t | nil,
    :OwnerMember => FoyerAPI.Model.Member.t | nil,
    :OriginatingSystem => FoyerAPI.Model.Ouid.t | nil,
    :SourceSystem => FoyerAPI.Model.Ouid.t | nil,
    :ContactListingNotes => [FoyerAPI.Model.ContactListingNotes.t] | nil,
    :ContactListings => [FoyerAPI.Model.ContactListings.t] | nil,
    :Prospectings => [FoyerAPI.Model.Prospecting.t] | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.Contacts do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:Anniversary, :date, nil, options)
    |> deserialize(:Birthdate, :date, nil, options)
    |> deserialize(:ModificationTimestamp, :date, nil, options)
    |> deserialize(:OriginalEntryTimestamp, :date, nil, options)
    |> deserialize(:OwnerMember, :struct, FoyerAPI.Model.Member, options)
    |> deserialize(:OriginatingSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:SourceSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:ContactListingNotes, :list, FoyerAPI.Model.ContactListingNotes, options)
    |> deserialize(:ContactListings, :list, FoyerAPI.Model.ContactListings, options)
    |> deserialize(:Prospectings, :list, FoyerAPI.Model.Prospecting, options)
  end
end

